#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep 30 11:48:05 2019

@author: zandieh
"""
import numpy as np
import torch


def FF(s, m, Xtrain, Xtest):
    
    n = Xtrain.shape[0]
    d = Xtest.shape[1]
    
    w = torch.from_numpy( np.random.normal(0, 1/(np.pi*np.sqrt(2*s)), (d,m)) )
    z = torch.from_numpy( np.random.uniform(0,2*np.pi,m) )
    
    Features_train = np.cos(2*np.pi*torch.mm(Xtrain, w) + z)/np.sqrt(m)
    
    Features_test = np.cos(2*np.pi*torch.mm(Xtest,w) + z)/np.sqrt(m)
    
    return Features_train, Features_test
